// Copyright (c) 2017 Czech Technical University in Prague | Faculty of Information Technology. All rights reserved.

#pragma once

#include <string>
#include <ostream>

namespace graph {

/**
 * Represents graph.
 */
class GraphBase {
public:
	virtual ~GraphBase ( ) noexcept = default;

// ---------------------------------------------------------------------------------------------------------------------

// ---------------------------------------------------------------------------------------------------------------------
	friend std::ostream & operator << ( std::ostream & os, const GraphBase & instance ) {
		instance >> os;
		return os;
	}

 public:

	virtual void operator >> ( std::ostream & os ) const = 0;

	virtual operator std::string ( ) const = 0;
};

} // namespace graph

